
package
{
	import mixi.MixiClient;
	import mixi.MixiClientEvent;
	import mixi.ProfForm;
	import mx.effects.Fade;
	import mx.controls.Label;
	import flash.events.MouseEvent;
	import mx.effects.Move;
	import mixi.ProfCarier;
	import flash.events.Event;
	import mx.events.EffectEvent;
	
	public class MainWindowHandler
	{
		private var window: MixiSoukanzu;
		private var mixiClient: MixiClient;

		public function MainWindowHandler(window: MixiSoukanzu) {
			this.window     = window;
			this.mixiClient = new MixiClient(window);
		}

		public function init(): void
		{
			// mixi 通信系イベントハンドラ設定
			mixiClient.addEventListener(MixiClientEvent.LOGIN_COMPLETE, onLogin);
			mixiClient.addEventListener(MixiClientEvent.SHOWINTRO_COMPLETE, onResult);

			// マウスイベントハンドラ設定
			for (var i:int = 0; i < 8; ++i) {
				var ctrl:ProfForm = window.getChildByName("prof" + (i+1)) as ProfForm;
				ctrl.addEventListener(MouseEvent.CLICK, userProfOnClick);
			}

			mixiClient.doLogin();
			
//			window.status = "ログイン処理中 ...";
		}

		// ログイン完了時に呼ばれるイベントハンドラ
		public function onLogin(e:MixiClientEvent):void {
//			window.status = "ログイン完了";
			
			var prof:Array = e.msg as Array;

			window.profMe.photo.addEventListener(
				Event.COMPLETE,
				function(e:Event) {window.profMe.showWithFade();}
			);
			window.profMe.setProfAttr(prof);
			window.profMe.photo.load(prof["image"]);
			
			// 紹介の取得
			mixiClient.getRelations(prof["id"]);
		}

		// １件のマイミクの情報を設定するメソッド
		private function setProf(ctrl:ProfForm, rel:Label, prof:Array):void {
			// 紹介文の「関係：」がある場合はリレーションを設定
			if (prof["relation"] != null) {
				rel.text = prof["relation"];
				rel.visible = true;
			} else {
				// 無い場合はとりあえず。。。
				rel.text = "マイミク";
				rel.visible = true;
			} 

			ctrl.photo.addEventListener(
				Event.COMPLETE,
				function(e:Event) {ctrl.showWithFade();}
			);
			ctrl.setProfAttr(prof);
			ctrl.photo.load(prof["image"]);

		}
		
		// 写真をクリックされたときに呼ばれるイベントハンドラ
		public function userProfOnClick(e:MouseEvent):void {
			var ctrl:ProfForm = e.currentTarget as ProfForm;
			
			// クリックされたマイミクの画面へ遷移するための一連の処理を行ってくれるクラス
			var carier:ProfCarier = new ProfCarier(window, mixiClient);
			
			carier.addEventListener(
				Event.COMPLETE,
				function(e:Event) {mixiClient.getRelations(ctrl.mixiId);}
			);
			
			// 処理開始
			carier.play(ctrl);
		}

		// 紹介文一覧取得完了時に呼ばれるイベントハンドラ
		public function onResult(e:MixiClientEvent):void {
			var prof:Array = e.msg as Array;
			var count:int = Math.min(8, prof.length);
			for (var i:int = 0; i < count; ++i) {
				setProf(
					window.getChildByName("prof" + (i+1)) as ProfForm,
					window.getChildByName("relation" + (i+1)) as Label,
					prof[i]
				);
			}
		}
 	}
}