package mixi
{
	import flash.html.HTMLControl;
	import mx.messaging.messages.HTTPRequestMessage;
	import mx.core.ClassFactory;
	import flash.events.Event;
	import flash.html.JavaScriptObject;
	import flash.net.URLRequest;
	import flash.html.JavaScriptFunction;
	import mx.controls.HTML;
	
	public class Browser
	{
		private var htmlControl:HTMLControl;
		private var cuurentRequest: MixiRequest;
		
		public function Browser():void {
			this.htmlControl = new HTMLControl();
			htmlControl.addEventListener(Event.COMPLETE, onLoaded);
		}

		public function onLoaded(e:Event):void {
			var doc: JavaScriptObject = htmlControl.window.document;
			var msg:MixiMessage = new ClassFactory(cuurentRequest.messageType).newInstance() as MixiMessage;
			
			// ログイン処理が必要か判定
			var redirectUrl:String = "";
			var metaTags:JavaScriptObject = doc.getElementsByTagName("meta");
			for (var i:int = 0; i < metaTags.length; ++i) {
				var meta:JavaScriptObject = metaTags[i] as JavaScriptObject
				if (meta.getAttribute("http-equiv") == "refresh") {
					var content:String = meta.getAttribute("content");
					redirectUrl = "https://mixi.jp" + content.replace(/.*;url=/, "");
				}
			}
			
			if (redirectUrl != "") {
				// リダイレクトを行う
				var req:MixiRequest = new MixiRequest(
					 new URLRequest(redirectUrl),
					 cuurentRequest.messageType,
					 cuurentRequest.messageHandler
				);
				sendMessage(req);

			} else {
				msg.setDocument(doc);
				cuurentRequest.messageHandler(msg);

			}
		}

		public function sendMessage(req:MixiRequest) {
			this.cuurentRequest = req;
			htmlControl.load(req.request);
		}
	}
}
