package mixi
{
	import mx.core.Container;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.net.URLRequest;
	import mx.controls.Alert;
	
	
	public class MixiClient extends EventDispatcher
	{
		private var window: Container;
		private var browser: Browser;
		private var loginForm: LoginForm;
		private var eventHandlers: Array = new Array();
		
		public function MixiClient(window: Container) {
			this.window = window;
			browser = new Browser();
			
			// 最初はトップページを表示しておく
			/*
			browser.sendMessage(
				new MixiRequest(
					new URLRequest("http://mixi.jp/home.pl"),
					MixiMessage,
					function(m:MixiMessage){
						Alert.show("初期URL表示完了");
					}
				)
			);
			*/
		}

		public function doLogin(): void
		{
			loginForm = new LoginForm(window, browser);
			loginForm.onLoginSucceed = function(m:MixiLoginMessage){
				dispatchEvent(new MixiClientEvent(MixiClientEvent.LOGIN_COMPLETE, m.getProf()));
			}
			loginForm.showLoginForm();
		}
		
		public function getPhotoLibList(): void
		{
			browser.sendMessage(
				new MixiRequest(
					new URLRequest("http://mixi.jp/list_album.pl"),
					MixiAlbumListMessage,
					function(m:MixiAlbumListMessage){
						dispatchEvent(new MixiClientEvent(MixiClientEvent.LISTPHOTOLIB_COMPLETE, m.getAlbumList()));
					}
				)
			);
		}
		
		public function getRelations(id:String):void
		{
			var s:RelationSearcher = new RelationSearcher(browser);
			s.onSearchEnd = function(a:Array) {
				dispatchEvent(new MixiClientEvent(MixiClientEvent.SHOWINTRO_COMPLETE, a));
			}
			s.getRelations(id);
		}
		
		public function getRelation(fromId:String, toId:String):void
		{
			var s:RelationSearcher = new RelationSearcher(browser);
			s.onSearchEnd = function(a:Array) {
				var targetProf:Array = null;
				for each (var prof:Array in a) {
					if (prof["id"] == toId) {
						targetProf = prof;
						break;
					}
				}
				dispatchEvent(new MixiClientEvent(MixiClientEvent.SHOWFRIENDINTRO_COMPLETE, targetProf));
			}
			s.getRelations(fromId);
		}
	}
}
